/*
  Color impression 4x 1" RGBDigit's on a RGBdigitSchield 
 
 The circuit:
 * Use the RGBDigitSchield or connect 1 or more RGBDigit's to yout Arduino UNO pin 12
 * RGBDigit Digit's attached on pin 12 Arduino microcontroller (UNO) 
 * Ad a 470 ohm resistor between pin 12 of the microcontroller and Data in (Di)Pin2 from first RGBDigit 
 * This code is configured for 4 1"RGBDigit's is 32 RGBLED's

 **************************************************************************************************************************************
 
 * NOTE  Do not connect RGBDigit's to a life arduino(UNO) controller                                                                  *
 * NOTE  The NeoPixel's are very sensitive for the correct connection order                                                           *
 * NOTE  See for more info the Basic Connection section on http://learn.adafruit.com/adafruit-neopixel-uberguide/arduino-library      *
  
 **************************************************************************************************************************************
 
 created 2015  
 by RGBDigit < http://rgbdigit.com >
 modified 1 Mrt 2015
 by Coen   RGBDigit
 Version SAND_V15.02.01
 
 This code is based on Adafruit_NeoPixel  URL  http://learn.adafruit.com/adafruit-neopixel-uberguide/arduino-library 
 This example code is in the public domain.

*/


#include <Adafruit_NeoPixel.h>
#define PIN1 12

byte Hold_on = 1;
// Parameter 1 = number of pixels in strip1
// Parameter 2 = pin number (most are valid)
// Parameter 3 = pixel type flags, add together as needed:
//   NEO_KHZ800  800 KHz bitstream (most NeoPixel products w/WS2812 LEDs)
//   NEO_KHZ400  400 KHz (classic 'v1' (not v2) FLORA pixels, WS2811 drivers)
//   NEO_GRB     Pixels are wired for GRB bitstream (most NeoPixel products)
//   NEO_RGB     Pixels are wired for RGB bitstream (v1 FLORA pixels, not v2)
Adafruit_NeoPixel strip1 = Adafruit_NeoPixel(32, PIN1, NEO_GRB + NEO_KHZ800);
//------end init ------------------------------------------------------------------

void setup() {
              strip1.begin();
              strip1.show(); // Initialize all pixels to 'off'
              strip1.setBrightness(50);
              }
//------end setup loop-------------------------------------------------------------

void loop() {
  // Some example procedures showing how to display to the pixels:
              delay(2000);
              if (Hold_on == 1) {
                                  colorWipe(strip1.Color(255, 0, 0), 100); // Red
                                  colorWipe(strip1.Color(0, 255, 0), 100); // Green
                                  colorWipe(strip1.Color(0, 0, 255), 100); // Blue
                                  rainbow(50);
                                  rainbowCycle(30);
                                 // Hold_on = 0;                          //  enable this line to hold loop after one cicle
                                }
             }
//------end void loop-------------------------------------------------------------

//------Adafruit sample code------------------------------------------------------
// Fill the dots one after the other with a color
void colorWipe(uint32_t c, uint8_t wait) {
  for(uint16_t i=0; i<strip1.numPixels(); i++) {
      strip1.setPixelColor(i, c);
      strip1.show();
      delay(wait);
  }
}

void rainbow(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256; j++) {
    for(i=0; i<strip1.numPixels(); i++) {
      strip1.setPixelColor(i, Wheel((i+j) & 255));
    }
    strip1.show();
    delay(wait);
  }
}

// Slightly different, this makes the rainbow equally distributed throughout
void rainbowCycle(uint8_t wait) {
  uint16_t i, j;

  for(j=0; j<256*5; j++) { // 5 cycles of all colors on wheel
    for(i=0; i< strip1.numPixels(); i++) {
      strip1.setPixelColor(i, Wheel(((i * 256 / strip1.numPixels()) + j) & 255));
    }
    strip1.show();
    delay(wait);
  }
}

// Input a value 0 to 255 to get a color value.
// The colours are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  if(WheelPos < 85) {
   return strip1.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
  } else if(WheelPos < 170) {
   WheelPos -= 85;
   return strip1.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  } else {
   WheelPos -= 170;
   return strip1.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
}


